
# created this file by ramsan on set-2003 ; modified on Apr-2004
package provide mkZiplib 1.0
namespace eval mkzip {}
proc mkzip::zip { args } {
    set recursive 0
    set compression 9
    set isdata 0
    for { set i 0 } { $i < [llength $args] } { incr i } {
	set todel 0
	switch -regexp -- [lindex $args $i] {
	    {^-r$} { set recursive 1 ; set todel 1 }
	    {^-[0-9]$} { set compression [string trimleft [lindex $args $i] -] ; set todel 1 }
	    {^-data$} { set isdata 1 ; set todel 1 }
	    {^-} { error "unkown option '[lindex $args $i]'" }
	}
	if { !$todel } { break }
	set args [lreplace $args $i [expr {$i+$todel-1}]]
	incr i [expr {-1*$todel}]
    }
    if { $isdata && $recursive } {
	error "error: options -data and -r cannot be used together in mkzip::zip"
    }
    set zipfile [lindex $args 0]
    set files [lrange $args 1 end]
    if { $recursive } {
	for { set i 0 } { $i < [llength $files] } { incr i } {
	    if { [file isdirectory [lindex $files $i]] } {
		eval lappend files [glob -nocomplain -dir [lindex $files $i] *]
	    }
	}
    }
    
    set h [::zip open $zipfile w]
    if { !$isdata } {
	foreach i $files {
	    if { [file isdirectory $i] } { continue }
	    ::zip set $h $i -level $compression -time [file mtime $i]
	    set fin [open $i r]
	    fconfigure $fin -translation binary
	    ::zip write $h [read $fin]
	    close $fin
	}
    } else {
	set now [clock seconds]
	foreach i $files {
	    foreach "name data" $i break
	    ::zip set $h $name -level $compression -time $now
	    ::zip write $h $data
	}
    }
    ::zip close $h
}
proc mkzip::unzip { args } {
    set overwrite ask
    set isdata 0
    for { set i 0 } { $i < [llength $args] } { incr i } {
	set todel 0
	switch -regexp -- [lindex $args $i] {
	    {^-o$} { set overwrite always ; set todel 1 }
	    {^-data$} { set isdata 1 ; set todel 1 }
	    {^-} { error "unkown option '[lindex $args $i]'" }
	}
	if { !$todel } { break }
	set args [lreplace $args $i [expr {$i+$todel-1}]]
	incr i [expr {-1*$todel}]
    }
    set zipfile [lindex $args 0]
    set retval ""
    set h [::zip open $zipfile r]
    if { !$isdata } {
	foreach file [::zip files $h] {
	    foreach "mtime csize size att comment" [::zip info $h $file] break
	    if { ![file exists [file dirname $file]] } { file mkdir [file dirname $file] }
	    if { [file exists $file] && $overwrite != "always" } {
		if { $overwrite == "ask" } {
		    package require Tk
		    set retval [tk_dialog .d "Confirm" "Do you want to overwrite file '$file'?" \
				    question 0 Yes "Yes to All" No "No to all" Cancel]
		    switch -- $retval {
			4 - -1 {
			    ::zip close $h
			    return
			}
			0 {
			    #nothing
			}
			1 { set overwrite always }
			2 { continue }
			3 { set overwrite never ; continue }
		    }
		} elseif { $overwrite == "never" } { continue }
	    }
	    ::zip set $h $file
	    set fout [open $file w]
	    fconfigure $fout -translation binary
	    puts -nonewline $fout [::zip read $h]
	    close $fout
	    file mtime $file $mtime
	    lappend retval [list $file $mtime]
	}
    } else {
	foreach file [::zip files $h] {
	    foreach "mtime csize size att comment" [::zip info $h $file] break
	    ::zip set $h $file
	    lappend retval [list $file $mtime [::zip read $h]]
	}
    }
    ::zip close $h
    return $retval
}
